function probability = ProbColsMatch(col1, col2, CharDict)
% Takes in two columns of text and a dictionary of of character strings the
% same width as the width of the two columns together and calculates the
% probability for that match in the language given by the dictionary.

% Constants
k = 1;
N = sum([CharDict{:,2}]);
numbercat = size(CharDict,1);

combinedcol = [col1 col2];

countvector = [];
%For each row
for i = 1:size(combinedcol,1)
    %Find index where that 4 letter string is stored
    index = find(strcmp(combinedcol(i,:),CharDict));
    if (isempty(index))
        count = 0;
    else
        count = CharDict{index,2};
    end
    countvector = [countvector count];
end

% Now find probability with Laplacian smoothing
probvector = (countvector + k)./(N+numbercat);
probability = prod(probvector);

end