function probability = ProbabilityWords(Words, Dictionary)
% This function outputs the probability that all of the words in the input
% cell arrays are words given a cell array of words and a dictionary of
% words.

% k
k = 1;

% Initialize some values
NewDict = [];

% Go through all of the words and make a count of how many times it appears
for i = 1:length(Dictionary)
    wordcount = 1;
    for j = i+1:length(Dictionary)
        if (strcmp(Dictionary{i}, Dictionary{j}))
            wordcount = wordcount + 1;
        end
    end
    NewDict = [NewDict; {Dictionary{i}, wordcount}];
end

% Figure out how many times each word appears in the Dictionary
countPerWord = [];
for i = 1:length(Words)
    curWord = Words{i};
    count = 0;
    for j = 1:size(NewDict,1)
        if (strcmp(curWord, NewDict{j,1}))
            count = count + NewDict{j,2};
        end
    end
    countPerWord = [countPerWord, count];
end

% Calculate proability of each word with LePlacian smooting
probabilitiesPerWord = (countPerWord + k)./(size(Dictionary,1) + k.*size(NewDict,1)); 

% Calculate end probability
probability = prod(probabilitiesPerWord);
end
